package wow.doge.http4sdemo

import monix.bio.IO
import monix.bio.Task
import monix.reactive.Observable
import slick.dbio.DBIOAction
import slick.dbio.NoStream
import slick.dbio.Streaming
import slick.jdbc.JdbcBackend.DatabaseDef

package object implicits {
  implicit class DatabaseDefExt(private val db: DatabaseDef) extends AnyVal {
    def runL[R](a: DBIOAction[R, NoStream, Nothing]) =
      Task.deferFuture(db.run(a))

    def streamO[T](a: DBIOAction[_, Streaming[T], Nothing]) =
      Observable.fromReactivePublisher(db.stream(a))
  }

  implicit final class MonixEvalTaskExt[T](private val task: monix.eval.Task[T])
      extends AnyVal {
    def toIO = IO.deferAction(implicit s => IO.from(task))
  }

  implicit final class MonixBioTaskExt[T](private val task: monix.bio.Task[T])
      extends AnyVal {
    def toTask =
      monix.eval.Task.deferAction(implicit s => monix.eval.Task.from(task))
  }

}
